unit MainUnit;
{ *************************************************
  *            FormRgn library 21.06.99           *
  *           written by Grigoriev Anton          *
  *                                               *
  *                  Demo program                 *
  ************************************************* }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FormRgn, Menus, NoTask, ExtCtrls;

type
  TCartoonForm = class(TForm)
    FormRegion: TFormRegion;
    Cartoon: TPictExtRgn;
    PopupMenu: TPopupMenu;
    ItemClose: TMenuItem;
    ItemAbout: TMenuItem;
    CaptionRegion: TCaptionRegion;
    N1: TMenuItem;
    ItemTop: TMenuItem;
    N2: TMenuItem;
    ItemPict: TMenuItem;
    ItemTimon: TMenuItem;
    ItemPumba: TMenuItem;
    ItemChief: TMenuItem;
    ItemTeapot: TMenuItem;
    Timer: TTimer;
    ItemAuto: TMenuItem;
    FRManager: TFRManager;
    procedure FormPaint(Sender: TObject);
    procedure ItemCloseClick(Sender: TObject);
    procedure ItemAboutClick(Sender: TObject);
    procedure ItemTopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ItemTimonClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure ItemAutoClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
   private
    Picts:array[0..3] of TBitmap;
    PictSelected:Integer;
    procedure SelectPicture(N:Integer);
  end;

var
  CartoonForm: TCartoonForm;

implementation

{$R *.DFM}
{$R Heroes.res}

procedure TCartoonForm.FormPaint(Sender: TObject);
 begin
  Canvas.Draw(Width-Cartoon.Glyph.Width,Height-Cartoon.Glyph.Height,Cartoon.Glyph)
 end;

procedure TCartoonForm.ItemCloseClick(Sender: TObject);
 begin
  Close
 end;

procedure TCartoonForm.ItemAboutClick(Sender: TObject);
 begin
  ShowMessage('Demo program from FormRgn library, written by Grigoriev Anton'#13#10'If it is interesting for you, e-mail me at duker@ipmt-hpm.ac.ru');
  ShowWindow(Application.Handle,SW_Hide)
 end;

procedure TCartoonForm.ItemTopClick(Sender: TObject);
 begin
  ItemTop.Checked:=not ItemTop.Checked;
  FRManager.StayOnTop(ItemTop.Checked)
 end;

procedure TCartoonForm.FormCreate(Sender: TObject);
 begin
  Randomize;
  Picts[0]:=TBitmap.Create;
  Picts[1]:=TBitmap.Create;
  Picts[2]:=TBitmap.Create;
  Picts[3]:=TBitmap.Create;
  Picts[0].LoadFromResourceName(HInstance,'HeroTimon');
  Picts[1].LoadFromResourceName(HInstance,'HeroPumba');
  Picts[2].LoadFromResourceName(HInstance,'HeroChief');
  Picts[3].LoadFromResourceName(HInstance,'HeroColleague');
  SelectPicture(Random(4));
  Left:=GetSystemMetrics(SM_CXFullScreen)-Width-2;
  Top:=GetSystemMetrics(SM_CYMaximized)-Height-10;
 end;

procedure TCartoonForm.SelectPicture;
 var I:Integer;
  begin
   for I:=0 to 3 do
    with ItemPict do
     Items[I].Checked:=Items[I].Tag=N;
   Cartoon.Glyph:=Picts[N];
   PictSelected:=N;
   Invalidate
  end;

procedure TCartoonForm.ItemTimonClick(Sender: TObject);
 begin
  SelectPicture((Sender as TComponent).Tag);
  Timer.Interval:=0;
  Timer.Interval:=300000
 end;

procedure TCartoonForm.TimerTimer(Sender: TObject);
 var P:Integer;
  begin
   repeat
    P:=Random(4)
   until P<>PictSelected;
   SelectPicture(P)
  end;

procedure TCartoonForm.ItemAutoClick(Sender: TObject);
 begin
  ItemAuto.Checked:=not ItemAuto.Checked;
  if ItemAuto.Checked then
   Timer.Interval:=300000
  else
   Timer.Interval:=0
 end;

procedure TCartoonForm.FormShow(Sender: TObject);
 begin
  ShowWindow(Application.Handle,SW_Hide)
 end;

end.
